/**
 * Copyright 2006-8 Simon Andrews
 *
 *    This file is part of ChIPMonk.
 *
 *    ChIPMonk is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    ChIPMonk is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with ChIPMonk; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package uk.ac.bbsrc.babraham.ChipMonk.Normalisation;

import uk.ac.bbsrc.babraham.ChipMonk.DataTypes.DataCollection;

public interface Normalisation {
	
	public void normalise (DataCollection d);
	
	// Used in labels so keep it short!
	public String shortDescription();
	
	// Longer description to explain the short description.  Probably good to
	// wrap this in <html> tags and use <br> to introuduce line breaks.
	public String longDescription();

	public void addNormalisationProgressListener (NormalisationProgressListener l);
	
	// Use this to inform the program if the dataset is going to be able
	// to be processed with this filter.  Don't do any really big
	// calculations in here, just a quick check.
	public boolean isSuitable (DataCollection d);
}

